// Markov chain music

import org.jfugue.*;
import java.util.*;
import java.io.*;

public class Markov {
  public static void main(String[] argv) throws Exception {
    Player player = new Player();
    //Scanner sc = new Scanner(System.in);
    
    // get initial song
    //System.out.print("Enter an initial piece in the form of a JFugue musicstring: ");
    //String song = sc.nextLine();
    //String song = "C C G G Ai Ai Ai Ai G F F E E D D C G Gi Gi F F E Ei Ei D G Gi Gi Fi Fi Fi Fi Ei Ei E D D C G G Ai Ai Ai Ai G F F E E D D C"; // Baa Baa Blacksheep
    //String song = "B A G A B B B R A A A R B D6 D6 R B A G A B B B B A A B A G"; // Mary had a little lamb
    String song = "C C G G A A G R F F E E D D C R G G F F E E D R " +
                  "G G F F E E D R C C G G A A G R F F E E D D C"; // Twinkle twinkle little star
    
    // play original song
    System.out.println("Playing original piece...");
    player.play(new Pattern(song));
    player.saveMidi(new Pattern(song), new File("original.midi"));
    
    // perform 0th degree Markov analysis (random piece)
    Random rand = new Random();
    String[] temp_scale = song.split(" ");
    int length = temp_scale.length;
    ArrayList<String> scale = new ArrayList<String>();
    System.out.print("Scale is: ");
    for(String s : temp_scale) {
      if (!scale.contains(s)) {
        scale.add(s);
        System.out.print(s + " ");
      }
    }
    System.out.println();
    String new_song = "";
    for (int i = 0; i < length; i++)
      new_song = new_song + scale.get(rand.nextInt(scale.size())) + " ";
    new_song = new_song.trim();
    System.out.println("0th degree Markov song: " + new_song);
    player.play(new Pattern(new_song));
    player.saveMidi(new Pattern(new_song), new File("zeroth.midi"));
    
    // perform 1st degree Markov analysis
    Scanner sc = new Scanner(song);
    Scanner sc2 = new Scanner(song);
    sc2.next();
    HashMap<String, ArrayList<String>> markov1 = new HashMap<String, ArrayList<String>>();
    for (String s : scale) {
      markov1.put(s, new ArrayList<String>());
    }
    // build chain
    while (sc2.hasNext()) {
      String temp = sc.next();
      ArrayList<String> temp2 = markov1.get(temp);
      temp2.add(sc2.next());
      markov1.put(temp, temp2);
    }
    for (String b : scale) {
      ArrayList<String> a = markov1.get(b);
      System.out.print(b + " => "); 
      for (String s : a) {
        System.out.print(s + " ");
      }
      System.out.println();
    }
    String new_song_1 = scale.get(rand.nextInt(scale.size())) + " ";
    for (int i = 0; i < length; i++) {
      //System.out.println(new_song_1);
      String[] splittemp = new_song_1.split(" ");
      ArrayList<String> a = markov1.get(splittemp[splittemp.length-1]);
      new_song_1 = new_song_1 + a.get(rand.nextInt(a.size())) + " ";
    }
    new_song_1 = new_song_1.trim();
    System.out.println("1st degree Markov song: " + new_song_1);
    player.play(new Pattern(new_song_1));
    player.saveMidi(new Pattern(new_song_1), new File("first.midi"));
    // perform 2nd degree Markov analysis
    
    System.exit(0);
  }
}
